/*
 * Fabric3
 * Copyright  2008 Metaform Systems Limited
 *
 * This proprietary software may be used only connection with the Fabric3 license
 * (the License), a copy of which is included in the software or may be
 * obtained at: http://www.metaformsystems.com/licenses/license.html.

 * Software distributed under the License is distributed on an as is basis,
 * without warranties or conditions of any kind.  See the License for the
 * specific language governing permissions and limitations of use of the software.
 * This software is distributed in conjunction with other software licensed under
 * different terms.  See the separate licenses for those programs included in the
 * distribution for the permitted and restricted uses of such software.
 *
 */
package org.fabric3.spring;

import org.fabric3.spi.ObjectFactory;
import org.springframework.context.support.AbstractApplicationContext;

/**
 * @version $Revision: 5481 $ $Date: 2008-09-26 02:36:30 -0700 (Fri, 26 Sep 2008) $
 */
public class SpringObjectFactory<T> implements ObjectFactory<T> {

    private AbstractApplicationContext scaApplicationContext;
    private T springBean = null;
    private String springBeanId = null;
    
    /**
     * Eager initiates the bean.
     */
    public SpringObjectFactory(AbstractApplicationContext scaApplicationContext, String springBeanId) {
        
        this.scaApplicationContext = scaApplicationContext;
        this.springBeanId = springBeanId;
        
    }

    @SuppressWarnings("unchecked")
    public T getInstance() {
        if (springBean == null) {
            this.scaApplicationContext.refresh();
            this.springBean = (T) scaApplicationContext.getBean(springBeanId);
        }
        return springBean;
    }

}
